&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME FrameDemo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS FrameDemo 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.       */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEF VAR pv_cColumnType AS CHAR NO-UNDO.

&SCOP LOGPIXELSX    88    /* Logical pixels/inch in X  */
&SCOP LOGPIXELSY    90    /* Logical pixels/inch in Y  */

DEFINE VARIABLE h-device AS INTEGER    NO-UNDO.
DEFINE VARIABLE pixels-x AS INTEGER    NO-UNDO.
DEFINE VARIABLE pixels-y AS INTEGER    NO-UNDO.
DEFINE VARIABLE v-scale-x AS DECIMAL DECIMALS 5   NO-UNDO.
DEFINE VARIABLE v-scale-y AS DECIMAL DECIMALS 5   NO-UNDO.

DEFINE VARIABLE h_TreeFrame AS COM-HANDLE NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Dialog-Box
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME FrameDemo

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS Btn_Cancel RECT-11 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_View 
       MENU-ITEM m_Large_Icons  LABEL "&Large Icons"  
       MENU-ITEM m_List         LABEL "&List"         
       MENU-ITEM m_Small_Icons  LABEL "&Small Icons"  
       MENU-ITEM m_Report       LABEL "&Report"       .

DEFINE SUB-MENU m_Sort 
       MENU-ITEM m_ascending    LABEL "&Ascending"    
              TOGGLE-BOX
       MENU-ITEM m_Descending   LABEL "&Descending"   
              TOGGLE-BOX.

DEFINE MENU POPUP-MENU-Dialog-Frame 
       SUB-MENU  m_View         LABEL "&View"         
       RULE
       SUB-MENU  m_Sort         LABEL "&Sort"         .


/* Definitions of handles for OCX Containers                            */
DEFINE VARIABLE LargeImageFrame AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chLargeImageFrame AS COMPONENT-HANDLE NO-UNDO.
DEFINE VARIABLE ListViewFrame AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chListViewFrame AS COMPONENT-HANDLE NO-UNDO.
DEFINE VARIABLE SmallImageFrame AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chSmallImageFrame AS COMPONENT-HANDLE NO-UNDO.
DEFINE VARIABLE TreeViewFrame AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chTreeViewFrame AS COMPONENT-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "&Close" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE RECTANGLE RECT-11
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 132 BY 19.05.

DEFINE BUTTON ButtonSplitter  NO-FOCUS FLAT-BUTTON NO-CONVERT-3D-COLORS
     LABEL "" 
     SIZE 1 BY 18.1.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME FrameDemo
     Btn_Cancel AT ROW 20.76 COL 120
     RECT-11 AT ROW 1.48 COL 3
     SPACE(1.79) SKIP(1.84)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "TreeView and ListView Demo"
         CONTEXT-HELP.

DEFINE FRAME FrameSplitter
     ButtonSplitter AT ROW 1 COL 45
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 5 ROW 1.95
         SIZE 128 BY 18.1.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Dialog-Box
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* REPARENT FRAME */
ASSIGN FRAME FrameSplitter:FRAME = FRAME FrameDemo:HANDLE.

/* SETTINGS FOR DIALOG-BOX FrameDemo
                                                                        */
ASSIGN 
       FRAME FrameDemo:SCROLLABLE       = FALSE
       FRAME FrameDemo:POPUP-MENU       = MENU POPUP-MENU-Dialog-Frame:HANDLE.

/* SETTINGS FOR FRAME FrameSplitter
                                                                        */
ASSIGN 
       ButtonSplitter:MOVABLE IN FRAME FrameSplitter          = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX FrameDemo
/* Query rebuild information for DIALOG-BOX FrameDemo
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX FrameDemo */
&ANALYZE-RESUME

 


/* **********************  Create OCX Containers  ********************** */

&ANALYZE-SUSPEND _CREATE-DYNAMIC

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

CREATE CONTROL-FRAME SmallImageFrame ASSIGN
       FRAME           = FRAME FrameDemo:HANDLE
       ROW             = 8.62
       COLUMN          = 11
       HEIGHT          = 4.76
       WIDTH           = 20
       HIDDEN          = yes
       SENSITIVE       = no.

CREATE CONTROL-FRAME TreeViewFrame ASSIGN
       FRAME           = FRAME FrameSplitter:HANDLE
       ROW             = 1
       COLUMN          = 1
       HEIGHT          = 18.1
       WIDTH           = 44
       HIDDEN          = no
       SENSITIVE       = yes.

CREATE CONTROL-FRAME ListViewFrame ASSIGN
       FRAME           = FRAME FrameSplitter:HANDLE
       ROW             = 1
       COLUMN          = 47
       HEIGHT          = 18.1
       WIDTH           = 82
       HIDDEN          = no
       SENSITIVE       = yes.

CREATE CONTROL-FRAME LargeImageFrame ASSIGN
       FRAME           = FRAME FrameSplitter:HANDLE
       ROW             = 12.67
       COLUMN          = 70
       HEIGHT          = 1.43
       WIDTH           = 33
       HIDDEN          = yes
       SENSITIVE       = no.
      SmallImageFrame:NAME = "SmallImageFrame":U .
/* SmallImageFrame OCXINFO:CREATE-CONTROL from: {2C247F23-8591-11D1-B16A-00C0F0283628} type: ImageList */
      TreeViewFrame:NAME = "TreeViewFrame":U .
/* TreeViewFrame OCXINFO:CREATE-CONTROL from: {C74190B6-8589-11D1-B16A-00C0F0283628} type: TreeView */
      ListViewFrame:NAME = "ListViewFrame":U .
/* ListViewFrame OCXINFO:CREATE-CONTROL from: {BDD1F04B-858B-11D1-B16A-00C0F0283628} type: ListView */
      LargeImageFrame:NAME = "LargeImageFrame":U .
/* LargeImageFrame OCXINFO:CREATE-CONTROL from: {2C247F23-8591-11D1-B16A-00C0F0283628} type: ImageList */
      SmallImageFrame:MOVE-AFTER(FRAME FrameSplitter:HANDLE).
      ListViewFrame:MOVE-AFTER(TreeViewFrame).
      LargeImageFrame:MOVE-AFTER(ListViewFrame).

&ENDIF

&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */


/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME FrameDemo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL FrameDemo FrameDemo
ON WINDOW-CLOSE OF FRAME FrameDemo /* TreeView and ListView Demo */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FrameSplitter
&Scoped-define SELF-NAME ButtonSplitter
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ButtonSplitter FrameDemo
ON END-MOVE OF ButtonSplitter IN FRAME FrameSplitter
DO:
  ASSIGN SELF:X = MAX(SELF:X,50)
         SELF:X = MIN(SELF:X,600)
         TreeViewFrame:WIDTH-PIXELS = (SELF:X - TreeViewFrame:X).

  IF SELF:X GE ListViewFrame:X THEN
       ASSIGN ListViewFrame:WIDTH-PIXELS = FRAME FrameSplitter:WIDTH-PIXELS - (SELF:X + SELF:WIDTH-PIXELS)
              ListViewFrame:X   = SELF:X + SELF:WIDTH-PIXELS.
            
  ELSE ASSIGN ListViewFrame:X   = SELF:X + SELF:WIDTH-PIXELS
              ListViewFrame:WIDTH-PIXELS = FRAME FrameSplitter:WIDTH-PIXELS - (SELF:X + SELF:WIDTH-PIXELS).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME ListViewFrame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ListViewFrame FrameDemo OCX.ColumnClick
PROCEDURE ListViewFrame.ListView.ColumnClick .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    ColumnHeader
  Notes:       
------------------------------------------------------------------------------*/

 DEF INPUT PARAMETER ip_chColumnHeader AS COM-HANDLE  NO-UNDO.
 
 IF ListViewFrame:PRIVATE-DATA EQ "":U OR ListViewFrame:PRIVATE-DATA NE STRING(ip_chColumnHeader:INDEX) THEN
    ASSIGN ListViewFrame:PRIVATE-DATA = STRING(ip_chColumnHeader:INDEX). /* store the last column header clicked */
 
 ELSE ASSIGN chListViewFrame:CONTROLS:ITEM(1):SortOrder = (IF chListViewFrame:CONTROLS:ITEM(1):SortOrder EQ 0 THEN 1 ELSE 0)
             MENU-ITEM m_Ascending:CHECKED IN MENU m_sort = IF chListViewFrame:CONTROLS:ITEM(1):SortOrder EQ 0 THEN YES ELSE NO
             MENU-ITEM m_Descending:CHECKED IN MENU m_sort = IF chListViewFrame:CONTROLS:ITEM(1):SortOrder EQ 0 THEN NO ELSE YES.
 
 ASSIGN chListViewFrame:CONTROLS:ITEM(1):Sorted  = yes
        chListViewFrame:CONTROLS:ITEM(1):SortKey = ip_chColumnHeader:Index - 1.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ListViewFrame FrameDemo OCX.DblClick
PROCEDURE ListViewFrame.ListView.DblClick .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  None required for OCX.
  Notes:       
------------------------------------------------------------------------------*/

 DEF VAR lv_chItem AS COM-HANDLE NO-UNDO.

 ASSIGN lv_chItem = chTreeViewFrame:CONTROLS:ITEM(1):Nodes(chListViewFrame:CONTROLS:ITEM(1):SelectedItem:KEY)
        lv_chItem:Selected = YES NO-ERROR.
 
 IF NOT VALID-HANDLE(lv_chItem) THEN RETURN NO-APPLY.

 /* Expand appropriate tree view node */
 RUN TreeViewFrame.TreeView.NodeClick IN THIS-PROCEDURE (lv_chItem).

 RELEASE OBJECT lv_chItem NO-ERROR. /* release when not needed */ 
    
 END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_ascending
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_ascending FrameDemo
ON VALUE-CHANGED OF MENU-ITEM m_ascending /* Ascending */
DO:
 ASSIGN chListViewFrame:CONTROLS:ITEM(1):SortOrder = IF SELF:CHECKED THEN 0 ELSE 1
        MENU-ITEM m_Descending:CHECKED IN MENU m_sort = NOT SELF:CHECKED
        chListViewFrame:CONTROLS:ITEM(1):Sorted = YES.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Descending
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Descending FrameDemo
ON VALUE-CHANGED OF MENU-ITEM m_Descending /* Descending */
DO:
 ASSIGN chListViewFrame:CONTROLS:ITEM(1):SortOrder = IF SELF:CHECKED THEN 1 ELSE 0
        MENU-ITEM m_Ascending:CHECKED IN MENU m_sort = NOT SELF:CHECKED
        chListViewFrame:CONTROLS:ITEM(1):Sorted = YES.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Large_Icons
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Large_Icons FrameDemo
ON CHOOSE OF MENU-ITEM m_Large_Icons /* Large Icons */
DO:
  ASSIGN chListViewFrame:CONTROLS:ITEM(1):View = 0.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_List
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_List FrameDemo
ON CHOOSE OF MENU-ITEM m_List /* List */
DO:
    ASSIGN chListViewFrame:CONTROLS:ITEM(1):View = 2.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Report
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Report FrameDemo
ON CHOOSE OF MENU-ITEM m_Report /* Report */
DO:
  ASSIGN chListViewFrame:CONTROLS:ITEM(1):View = 3.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Small_Icons
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Small_Icons FrameDemo
ON CHOOSE OF MENU-ITEM m_Small_Icons /* Small Icons */
DO:
 ASSIGN chListViewFrame:CONTROLS:ITEM(1):View = 1.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME TreeViewFrame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL TreeViewFrame FrameDemo OCX.Expand
PROCEDURE TreeViewFrame.TreeView.Expand .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    Node
  Notes:       
------------------------------------------------------------------------------*/

 DEF INPUT PARAMETER ip_chNode AS COM-HANDLE NO-UNDO.

 ip_chNode:EnsureVisible().

 RUN TreeViewFrame.TreeView.NodeClick IN THIS-PROCEDURE (ip_chNode).

 RELEASE OBJECT ip_chNode NO-ERROR.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL TreeViewFrame FrameDemo OCX.NodeClick
PROCEDURE TreeViewFrame.TreeView.NodeClick .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    Node
  Notes:       
------------------------------------------------------------------------------*/

 DEF INPUT PARAMETER ip_chNode AS COM-HANDLE NO-UNDO. /* COM-HANDLE of Node That was clicked */

 IF ip_chNode:Child NE 0 AND ip_chNode:Child:KEY BEGINS "#":U THEN /* a dummy node - rebuild */
 DO:
  h_TreeFrame:Nodes:Remove(ip_chNode:Child:KEY).
  RUN BuildCustomer IN THIS-PROCEDURE (ip_chNode). /* only dummy is on customers */
 END.

 IF ip_chNode:Child EQ 0 THEN /* has not yet been expanded (no children), therefore expand children */
    RUN VALUE("Expand":U + ENTRY(1,ip_chNode:Key)) IN THIS-PROCEDURE (ip_chNode) NO-ERROR.

 /* build list view of selected node */ 
 RUN VALUE("Build":U  + ENTRY(1,ip_chNode:Key)) IN THIS-PROCEDURE (ip_chNode) NO-ERROR.

 RELEASE OBJECT ip_chNode. /* release object when done */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL TreeViewFrame FrameDemo OCX.OLEDragDrop
PROCEDURE TreeViewFrame.TreeView.OLEDragDrop .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    Data
    Effect
    Button
    Shift
    x
    y
  Notes:       
------------------------------------------------------------------------------*/

DEFINE INPUT-OUTPUT PARAMETER p-Data   AS COM-HANDLE NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-Effect AS INTEGER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-Button AS INTEGER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-Shift  AS INTEGER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-x      AS DECIMAL NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-y      AS DECIMAL NO-UNDO.

DEFINE VARIABLE d-x     AS DECIMAL    NO-UNDO.
DEFINE VARIABLE d-y     AS DECIMAL    NO-UNDO.

DEF VAR lv_chNode   AS COM-HANDLE NO-UNDO.
DEF VAR lv_Nothing  AS INTEGER NO-UNDO.

RUN get-mouse-point   (INPUT h_TreeFrame,
                       OUTPUT d-x,
                       OUTPUT d-y).

ASSIGN lv_chnode = COM-SELF:HitTest(d-x AS FLOAT , d-y AS FLOAT).

IF NOT lv_chNode = 0 THEN
DO:
  MESSAGE "Drag From Data =" p-data:getdata(1) SKIP
          "Drag Onto Item =" h_TreeFrame:DropHighlight:Text VIEW-AS ALERT-BOX.
END.

/* Reset the DropHighLight to be Nothing */
ASSIGN lv_chnode = COM-SELF:HitTest(0 , 0).
h_TreeFrame:DropHighlight = lv_chNode.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL TreeViewFrame FrameDemo OCX.OLEDragOver
PROCEDURE TreeViewFrame.TreeView.OLEDragOver .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    Data
    Effect
    Button
    Shift
    x
    y
    State
  Notes:       
------------------------------------------------------------------------------*/

DEFINE INPUT-OUTPUT PARAMETER p-Data   AS COM-HANDLE NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-Effect AS INTEGER NO-UNDO. DEFINE INPUT-OUTPUT PARAMETER p-Button AS INTEGER NO-UNDO. DEFINE INPUT-OUTPUT PARAMETER p-Shift  AS INTEGER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-x      AS DECIMAL NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-y      AS DECIMAL NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-State  AS INTEGER NO-UNDO.

DEFINE VARIABLE check-node AS COM-HANDLE     NO-UNDO.

DEF VAR lv_chNode AS COM-HANDLE NO-UNDO.

  DEFINE VARIABLE d-x     AS DECIMAL    NO-UNDO.
  DEFINE VARIABLE d-y     AS DECIMAL    NO-UNDO.

  RUN get-mouse-point   (INPUT h_TreeFrame,
                         OUTPUT d-x,
                         OUTPUT d-y).

  ASSIGN lv_chNode    = COM-SELF:HitTest(d-x,d-y).

  ASSIGN h_TreeFrame:DropHighlight = lv_chNode.
  
  /* check-node = lv_chNode:NEXT NO-ERROR. 
  
  check-node = lv_chNode.

  IF VALID-HANDLE(check-node) THEN
  DO:
    check-node:EnsureVisible.
  END.

  check-node = lv_chNode:previous NO-ERROR.

  IF VALID-HANDLE(check-node) THEN
  DO:
    check-node:EnsureVisible.
  END.
  */
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL TreeViewFrame FrameDemo OCX.OLEStartDrag
PROCEDURE TreeViewFrame.TreeView.OLEStartDrag .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  Required for OCX.
    Data
    AllowedEffects
  Notes:       
------------------------------------------------------------------------------*/

DEFINE INPUT-OUTPUT PARAMETER p-Data           AS COM-HANDLE NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER p-AllowedEffects AS INTEGER NO-UNDO.

DEFINE VARIABLE d-x     AS DECIMAL    NO-UNDO.
DEFINE VARIABLE d-y     AS DECIMAL    NO-UNDO.

DEF VAR lv_chNode AS COM-HANDLE NO-UNDO.

RUN get-mouse-point   (INPUT h_TreeFrame,
                       OUTPUT d-x,
                       OUTPUT d-y).

ASSIGN lv_chNode = COM-SELF:HitTest(d-x AS FLOAT , 
                                    d-y AS FLOAT).

IF NOT lv_chNode = 0 THEN DO:
  p-data:SetData(lv_chNode:KEY). 
END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME FrameDemo
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK FrameDemo 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  ButtonSplitter:LOAD-MOUSE-POINTER("SIZE-E":U). /* make button have sizing arrow on mouse over */

  RUN enable_UI.

  APPLY "END-MOVE":U TO ButtonSplitter. /* make the screen pretty */

  RUN StartUp IN THIS-PROCEDURE NO-ERROR.

  WAIT-FOR WINDOW-CLOSE OF FRAME {&FRAME-NAME}.

END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE BuildCustomer FrameDemo 
PROCEDURE BuildCustomer :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
 DEF INPUT PARAMETER ip_chNode    AS COM-HANDLE NO-UNDO.

 DEF VAR lv_iOrderNum AS INT NO-UNDO.
 
 DEF VAR lv_chItem AS COM-HANDLE NO-UNDO.
 DEF VAR lv_chNode AS COM-HANDLE NO-UNDO.
 
 DEF VAR lv_iFirst AS INT NO-UNDO.
 DEF VAR lv_iLast  AS INT NO-UNDO.
 DEF VAR lv_i      AS INT NO-UNDO.
 
 DEF VAR lv_cColumns AS CHAR NO-UNDO INIT "Order,Instructions,Ship,Promised,Sales Rep,PO Number,Ordered,Carrier,Terms".

 ASSIGN lv_chNode = ip_chNode:Child:FirstSibling NO-ERROR.

 IF NOT VALID-HANDLE(lv_chNode) THEN RETURN.        
 
 IF pv_cColumnType NE "Order":U THEN /* need to create new columns */
 DO:
  chListViewFrame:CONTROLS:ITEM(1):ColumnHeaders:Clear().
 
  DO lv_i = 1 TO NUM-ENTRIES(lv_cColumns):
   ASSIGN lv_chItem = chListViewFrame:CONTROLS:ITEM(1):ColumnHeaders:Add(,,ENTRY(lv_i,lv_cColumns)).
   RELEASE OBJECT lv_chItem. /* release when done */
  END.
  
  ASSIGN pv_cColumnType = "Order":U.
 END.

 chListViewFrame:CONTROLS:ITEM(1):ListItems:Clear(). /* clear all existing listview entries */
 
 ASSIGN lv_iFirst = ip_chNode:Child:FirstSibling:Index 
        lv_iLast   = ip_chNode:Child:LastSibling:Index. /* get first & last Children of tree view node */
        
 /* we do this so that we can store the tree view node in the key of the list item. 
     this enables us to allow the user to double click in the list view, get the node that we need to 
     expand, and expand it. This will then show the children of the list view.
 */
 
 DO lv_i = lv_iFirst TO lv_iLast:
  ASSIGN lv_iOrderNum = INT(ENTRY(2,lv_chNode:Key)). /* tree view has been already created, therefore all data is there */
  
  FIND Order WHERE Order.OrderNum EQ lv_iOrderNum NO-LOCK NO-ERROR.

  ASSIGN lv_chItem = chListViewFrame:CONTROLS:ITEM(1):ListItems:Add(,lv_chNode:KEY, /* storing tree view node in listview key */
                                               STRING(Order.OrderNum),1,1).
               
   ASSIGN lv_chItem:SubItems(1) = Order.Instructions 
          lv_chItem:SubItems(2) = IF Order.ShipDate EQ ? THEN "" ELSE STRING(Order.ShipDate)
          lv_chItem:SubItems(3) = Order.PromiseDate 
          lv_chItem:SubItems(4) = Order.SalesRep 
          lv_chItem:SubItems(5) = Order.PO 
          lv_chItem:SubItems(7) = Order.Carrier 
          lv_chItem:SubItems(8) = Order.Terms.

  RELEASE OBJECT lv_chItem. /* release when doen */
  
  ASSIGN lv_chItem = lv_chNode /* store current node */
         lv_chNode = lv_chNode:Next. /* mode onto the next tree view node */

  RELEASE OBJECT lv_chItem. /* release original node */

  IF NOT VALID-HANDLE(lv_chNode) THEN LEAVE. /* just in case .. */

 END.
 
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE BuildOrder FrameDemo 
PROCEDURE BuildOrder :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
 DEF INPUT PARAMETER ip_chNode    AS COM-HANDLE NO-UNDO.

 DEF VAR lv_iOrderNum AS INT NO-UNDO.
 DEF VAR lv_i         AS INT NO-UNDO.

 DEF VAR lv_chItem AS COM-HANDLE NO-UNDO.
 
 DEF VAR lv_cColumns AS CHAR NO-UNDO INIT "Line,Item,Description,Price,Qty".
 
 ASSIGN lv_iOrderNum = INT(ENTRY(2,ip_chNode:Key)).
 
 IF pv_cColumnType NE "OrderLine":U THEN
 DO:
  chListViewFrame:CONTROLS:ITEM(1):ColumnHeaders:Clear().
 
  DO lv_i = 1 TO NUM-ENTRIES(lv_cColumns):
   ASSIGN lv_chItem = chListViewFrame:CONTROLS:ITEM(1):ColumnHeaders:Add(,,ENTRY(lv_i,lv_cColumns)).
   RELEASE OBJECT lv_chItem. /* release when done */
  END.

  ASSIGN pv_cColumnType = "OrderLine":U.
 END.

 chListViewFrame:CONTROLS:ITEM(1):ListItems:Clear().
 
 /* as we are not expaning orderlines in the tree view, we do not need to be as complicated as building 
    the orders list view */

 FOR EACH OrderLine WHERE OrderLine.OrderNum EQ lv_iOrderNum NO-LOCK,
     FIRST Item OF Orderline NO-LOCK:

  ASSIGN lv_chItem = chListViewFrame:CONTROLS:ITEM(1):ListItems:Add(,"OrderLine,":U + STRING(OrderLine.OrderNum)
                                                           + "-":U + STRING(OrderLine.LineNum) 
                                                           + ",":U + STRING(ip_chNode:Key),
                                            STRING(OrderLine.LineNum),2,2).
               
  ASSIGN lv_chItem:SubItems(1) = OrderLine.ItemNum
         lv_chItem:SubItems(2) = Item.ItemName
         lv_chItem:SubItems(3) = STRING(OrderLine.Price,"->>>>>9.99")
         lv_chItem:SubItems(4) = OrderLine.Qty.

  RELEASE OBJECT lv_chItem. /* release when done */
 END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load FrameDemo  _CONTROL-LOAD
PROCEDURE control_load :
/*------------------------------------------------------------------------------
  Purpose:     Load the OCXs    
  Parameters:  <none>
  Notes:       Here we load, initialize and make visible the 
               OCXs in the interface.                        
------------------------------------------------------------------------------*/

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN
DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.
DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.

OCXFile = SEARCH( "TreeViewDemo.wrx":U ).
IF OCXFile = ? THEN
  OCXFile = SEARCH(SUBSTRING(THIS-PROCEDURE:FILE-NAME, 1,
                     R-INDEX(THIS-PROCEDURE:FILE-NAME, ".":U), "CHARACTER":U) + "wrx":U).

IF OCXFile <> ? THEN
DO:
  ASSIGN
    chLargeImageFrame = LargeImageFrame:COM-HANDLE
    UIB_S = chLargeImageFrame:LoadControls( OCXFile, "LargeImageFrame":U)
    chListViewFrame = ListViewFrame:COM-HANDLE
    UIB_S = chListViewFrame:LoadControls( OCXFile, "ListViewFrame":U)
    chSmallImageFrame = SmallImageFrame:COM-HANDLE
    UIB_S = chSmallImageFrame:LoadControls( OCXFile, "SmallImageFrame":U)
    chTreeViewFrame = TreeViewFrame:COM-HANDLE
    UIB_S = chTreeViewFrame:LoadControls( OCXFile, "TreeViewFrame":U)
  .
  RUN initialize-controls IN THIS-PROCEDURE NO-ERROR.
END.
ELSE MESSAGE "TreeViewDemo.wrx":U SKIP(1)
             "The binary control file could not be found. The controls cannot be loaded."
             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".

&ENDIF

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI FrameDemo  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME FrameDemo.
  HIDE FRAME FrameSplitter.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI FrameDemo  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  RUN control_load.
  ENABLE Btn_Cancel RECT-11 
      WITH FRAME FrameDemo.
  {&OPEN-BROWSERS-IN-QUERY-FrameDemo}
  ENABLE ButtonSplitter 
      WITH FRAME FrameSplitter.
  {&OPEN-BROWSERS-IN-QUERY-FrameSplitter}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ExpandCustomer FrameDemo 
PROCEDURE ExpandCustomer :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
 DEF INPUT PARAMETER ip_chNode    AS COM-HANDLE NO-UNDO.

 DEF VAR lv_chNOde AS COM-HANDLE NO-UNDO.

 DEF VAR lv_iCustNum AS INT NO-UNDO.
 
 DEF VAR lv_cKey AS CHAR NO-UNDO.
 
 ASSIGN lv_iCustNum = INT(ENTRY(2,ip_chNode:Key)).
 
 FOR EACH Order FIELDS (Order.Ordernum) WHERE Order.CustNum EQ lv_iCustNum NO-LOCK: /* add order as a child of the customer tree view node */
  ASSIGN lv_cKey   = "Order," + STRING(Order.OrderNum)
         lv_chNode = chTreeViewFrame:CONTROLS:ITEM(1):Nodes:Add(ip_chNode:Index,4,lv_cKey,STRING(Order.OrderNum),1,2).

  RELEASE OBJECT lv_chNode. /* release when done */
 END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Get-Mouse-Point FrameDemo 
PROCEDURE Get-Mouse-Point :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER ip-com-object AS COM-HANDLE     NO-UNDO.
  DEFINE OUTPUT PARAMETER op-x          AS DECIMAL    NO-UNDO.
  DEFINE OUTPUT PARAMETER op-y          AS DECIMAL    NO-UNDO.
  
  DEFINE VARIABLE lppoint AS MEMPTR     NO-UNDO. /* Point Far */
  DEFINE VARIABLE v-point AS MEMPTR     NO-UNDO.
  DEFINE VARIABLE point   AS INTEGER    NO-UNDO.
  
  SET-SIZE(lppoint) = 8.
  
  RUN GetCursorPos(INPUT GET-POINTER-VALUE(lppoint),
                   OUTPUT point).

  RUN ScreenToClient(INPUT  ip-com-object:HWND, 
                     INPUT  GET-POINTER-VALUE(lppoint),
                     OUTPUT point).

  SET-SIZE(v-point) = 4.
  
  PUT-SHORT(v-point, 1) = GET-LONG(lppoint,1) /* abs( integer(p-x) ) */.
  PUT-SHORT(v-point, 3) = GET-LONG(lppoint,5)  /* abs( integer(p-y) ) */.
  
  ASSIGN op-x = DECIMAL(GET-LONG(lppoint,1)) * v-scale-x
         op-y = DECIMAL(GET-LONG(lppoint,5)) * v-scale-y.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initialize-controls FrameDemo 
PROCEDURE initialize-controls :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  h_TreeFrame = chTreeViewFrame:CONTROLS:ITEM(1).

  RUN GetDC( INPUT h_TreeFrame:HWND,
             OUTPUT h-device). 

  RUN GetDeviceCaps(OUTPUT pixels-x, 
                           h-device, 
                           {&LOGPIXELSX} ).
  RUN GetDeviceCaps(OUTPUT pixels-y, 
                           h-device, 
                           {&LOGPIXELSY} ).

  RUN ReleaseDC(INPUT h_TreeFrame:HWND, 
                INPUT h-device).

  /* Compute conversion factor pixels to twips
  ** Hittest LIKES twips (=1/1440 inch) */
  ASSIGN v-scale-x = 1440.0 / DECIMAL(pixels-x)
         v-scale-y = 1440.0 / DECIMAL(pixels-y).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE StartUp FrameDemo 
PROCEDURE StartUp :
DEF VAR lv_chRootNode  AS COM-HANDLE NO-UNDO.
 DEF VAR lv_chNode      AS COM-HANDLE NO-UNDO.
 DEF VAR lv_chDummyNode AS COM-HANDLE NO-UNDO.

 DEF VAR lv_cKey AS CHAR NO-UNDO.

 ASSIGN chTreeViewFrame:CONTROLS:ITEM(1):ImageList  = chSmallImageFrame:CONTROLS:ITEM(1) /* set pictures for TreeView */
        chListViewFrame:CONTROLS:ITEM(1):SmallIcons = chSmallImageFrame:CONTROLS:ITEM(1) /* set pictures for ListView Small icons */
        chListViewFrame:CONTROLS:ITEM(1):Icons      = chLargeImageFrame:CONTROLS:ITEM(1) /* set pictures for ListView Large Icons */
        lv_chRootNode = chTreeViewFrame:CONTROLS:ITEM(1):Nodes:Add(,,"custdemo","Customers",1,2). /* add first node of tree view */

         /* Parameters for add are
            1 - Relative     Index or Key of existing Node
            2 - Relationship Relative Placement # of new Node in Relation To node defined by (1)
                # = 1 (Last) Node is placed after all other nodes of same level 
                    2 (Next) Node is placed after node defined by (1)
                    3 (Prev) Node is placed before node defined by (1)
                    4 (Child) [Default] Node becomes a child of node defined by (1)
            3 - Unique String Key (Unique in entire tree view)
            4 - Text String for node [this is the only required parameter]
            5 - Image Index of image in imagelist for node
            6 - SelectedImage Index of image in imagelist for selected Node
          */

  /* build all customers */
           
  FOR EACH Customer FIELDS (Customer.Name Customer.CustNum) NO-LOCK  BY Customer.Name :
   ASSIGN FRAME {&FRAME-NAME}:TITLE = SUBSTITUTE("Please Wait, Loading Customer &1",Customer.NAME).
   ASSIGN lv_cKey = "Customer," + STRING(Customer.CustNum) /* unique key */
          lv_chNode = chTreeViewFrame:CONTROLS:ITEM(1):Nodes:Add(lv_chRootNode:Index,4,lv_cKey,Customer.Name + " (" + STRING(Customer.CustNum) + ")",1,2)
          lv_chDummyNode = chTreeViewFrame:CONTROLS:ITEM(1):Nodes:Add(lv_chNode:Index,4,"#,":U + lv_cKey,"Dummy",1,2).
    /* add each customer as a child of the root node pv_chTreeRoot */
   RELEASE OBJECT lv_chNode. /* release when done */
   RELEASE OBJECT lv_chDummyNode .
  END.

  RELEASE OBJECT lv_chRootNode. /* release when done */
  
  ASSIGN FRAME {&FRAME-NAME}:TITLE = "TreeView and ListView Demo".

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE WinAPI FrameDemo 
PROCEDURE WinAPI :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

END PROCEDURE.

PROCEDURE GetDC EXTERNAL "user32":
  DEFINE INPUT  PARAMETER window-handle AS LONG.
  DEFINE RETURN PARAMETER device-handle AS LONG.
END PROCEDURE.

PROCEDURE ReleaseDC EXTERNAL "user32":
  DEFINE INPUT  PARAMETER window-handle AS LONG. 
  DEFINE INPUT  PARAMETER device-handle AS LONG.
END PROCEDURE. 

PROCEDURE GetCursorPos EXTERNAL "user32":
  DEFINE INPUT  PARAMETER  lpPoint     AS LONG. /* memptr */
  DEFINE RETURN PARAMETER  ReturnValue AS LONG.
END PROCEDURE.

PROCEDURE ScreenToClient EXTERNAL "user32" :
   DEFINE INPUT  PARAMETER hWnd        AS LONG.
   DEFINE INPUT  PARAMETER lpPoint     AS LONG. /* memptr */
   DEFINE RETURN PARAMETER ReturnValue AS LONG.
END PROCEDURE.

PROCEDURE GetDeviceCaps EXTERNAL "GDI32":
  DEFINE RETURN PARAMETER r-value       AS LONG.
  DEFINE INPUT  PARAMETER device-handle AS LONG.
  DEFINE INPUT  PARAMETER caps-index    AS LONG. 
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

